petsc-3.12.1 2019-10-22
Report Typos and Errors

# PCBJACOBI

Use block Jacobi preconditioning, each block is (approximately) solved with its own KSP object.

### Options Database Keys

| -pc_use_amat | - use Amat to apply block of operator in inner Krylov method
| -pc_bjacobi_blocks <n> | - use n total blocks

### Notes

Each processor can have one or more blocks, or a single block can be shared by several processes. Defaults to one block per processor.

To set options on the solvers for each block append -sub_ to all the KSP, KSP, and PC options database keys. For example, -sub_pc_type ilu -sub_pc_factor_levels 1 -sub_ksp_type preonly

To set the options on the solvers separate for each block call PCBJacobiGetSubKSP() and set the options directly on the resulting KSP object (you can access its PC KSPGetPC())

For GPU-based vectors (CUDA, ViennaCL) it is recommended to use exactly one block per MPI process for best performance. Different block partitioning may lead to additional data transfers between host and GPU that lead to degraded performance.

The options prefix for each block is sub_, for example -sub_pc_type lu.

When multiple processes share a single block, each block encompasses exactly all the unknowns owned its set of processes.

### See Also

PCCreate(), PCSetType(), PCType (for list of available types), PC,
PCASM, PCSetUseAmat(), PCGetUseAmat(), PCBJacobiGetSubKSP(), PCBJacobiSetTotalBlocks(), PCBJacobiSetLocalBlocks(), PCSetModifySubmatrices()

### Level

beginner

### Location

src/ksp/pc/impls/bjacobi/bjacobi.c

### Examples

src/ksp/ksp/examples/tutorials/ex7.c.html
src/ksp/ksp/examples/tutorials/ex7f.F90.html
Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages